<?php

namespace Intergo\SubscriptionClient;

use Intergo\BaseClient\ApiHandler;
use Intergo\BaseClient\Enums\HttpMethodEnum;

class SubscriptionApiHandler extends ApiHandler
{
    protected static array $endpoints = [
        //Plans
        'getPlans' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plans', self::INTERNAL => true],
        'getPlanById' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plans/:id', self::INTERNAL => true],
        'createPlan' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plans', self::INTERNAL => true],
        'updatePlan' => [self::METHOD => HttpMethodEnum::PUT, self::URL => '/plans/:id', self::INTERNAL => true],
        'deletePlan' => [self::METHOD => HttpMethodEnum::DELETE, self::URL => '/plans/:id', self::INTERNAL => true],
        'getPlansByIds' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plans/ids', self::INTERNAL => true],

        // Plan Types
        'getPlanTypes' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plan-types', self::INTERNAL => true],
        'getPlanTypeById' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/plan-types/:id', self::INTERNAL => true],
        'createPlanType' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/plan-types', self::INTERNAL => true],
        'updatePlanType' => [self::METHOD => HttpMethodEnum::PUT, self::URL => '/plan-types/:id', self::INTERNAL => true],
        'deletePlanType' => [self::METHOD => HttpMethodEnum::DELETE, self::URL => '/plan-types/:id', self::INTERNAL => true],

        //Subscriptions
        'getSubscriptions' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/subscriptions', self::INTERNAL => true],
        'getSubscriptionById' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/subscriptions/:id', self::INTERNAL => true],
        'storeSubscription' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/subscriptions', self::INTERNAL => true],
        'updateSubscription' => [self::METHOD => HttpMethodEnum::PUT, self::URL => '/subscriptions/:id', self::INTERNAL => true],
        'bulkCancelSubscriptions' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/subscriptions/bulk-cancel', self::INTERNAL => true],
        'checkIfCancelled' => [self::METHOD => HttpMethodEnum::POST, self::URL => '/subscriptions/check/cancelled', self::INTERNAL => true],
        'getUserSubscriptions' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/subscriptions/user/:id', self::INTERNAL => true],
        'getSubscriptionBillingLogsBasedOnSubscriptionId' => [self::METHOD => HttpMethodEnum::GET, self::URL => '/subscriptions/:id/logs', self::INTERNAL => true],
    ];
}
